Bug 1272652 - Review Request: tktable - Table/matrix widget extension to Tcl/Tk
Review Request: tktable - Table/matrix widget extension to Tcl/Tk
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jerry James
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-17 06:10 EDT by Antonio Trande
Modified: 2015-11-09 19:51 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-11-09 16:53:40 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
loganjerry: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Antonio Trande 2015-10-17 06:10:08 EDT
Spec URL: https://sagitter.fedorapeople.org/tktable/tktable.spec
SRPM URL: https://sagitter.fedorapeople.org/tktable/tktable-2.10-1.fc22.src.rpm

Description:
Tktable provides a table/matrix widget for Tk programs. Features:
multi-line cells, embedded windows, variable width columns/height rows
(interactively resizable), scrollbar support, tag styles per row,
column or cell, in-cell editing, works on UNIX, Windows and MacIntosh,
Unicode support with Tk 8.1 and above.

Fedora Account System Username: sagitter

This is a re-review provided for by un-retiring guidelines (https://fedoraproject.org/wiki/Orphaned_package_that_need_new_maintainers).

Note

Copr project: http://copr-fe.cloud.fedoraproject.org/coprs/sagitter/tktable/
Comment 1 Richard Shaw 2015-10-17 08:49:08 EDT
Quick spec review first:

1. Location of Summary tag is weird but not a problem.

2. Group tags are not required

3. BuildRoot tag not required unless you want to support RHEL 5.

4. Automake builds are not usually verbose unless V=1 is added to the make command (more detail in the build logs is better)

5. rm -rf $RPM_BUILD_ROOT in %install not needed

6. %clean not required unless supporting RHEL 5 

7. %{!?_licensedir:%global license %doc} -- Have you verified this works? I know it was a suggestion on the ticket but it was found not to work, I use:
%if 0%{?rhel} < 7 || 0%{?fedora} < 21
%doc COPYING
%else
%license COPYING
%endif

8. %defattr(-,root,root) not needed.

9. "%_mandir/mann/tkTable.*" -- Strange that mandir isn't in {} but I guess it works fine.
Comment 2 Antonio Trande 2015-10-17 09:14:50 EDT
Hi Richard.

(In reply to Richard Shaw from comment #1)
> Quick spec review first:
> 
> 1. Location of Summary tag is weird but not a problem.

Yep. I will move it in a "traditional" location.

> 
> 2. Group tags are not required
> 
> 3. BuildRoot tag not required unless you want to support RHEL 5.
> 
> 
> 5. rm -rf $RPM_BUILD_ROOT in %install not needed
> 
> 6. %clean not required unless supporting RHEL 5 
> 
> 8. %defattr(-,root,root) not needed.

Everything predetermined. 
I wish to package it in EPEL5.

> 
> 7. %{!?_licensedir:%global license %doc} -- Have you verified this works?

It works of course. http://fedoraproject.org/wiki/EPEL:Packaging#The_.25license_tag

> 
> 9. "%_mandir/mann/tkTable.*" -- Strange that mandir isn't in {} but I guess
> it works fine.

Some packagers use this form.
Changed even if it would have worked in any case.

Spec URL: https://sagitter.fedorapeople.org/tktable/tktable.spec
SRPM URL: https://sagitter.fedorapeople.org/tktable/tktable-2.10-2.fc22.src.rpm
Comment 3 Antonio Trande 2015-10-17 14:03:06 EDT
Spec URL: https://sagitter.fedorapeople.org/tktable/tktable.spec
SRPM URL: https://sagitter.fedorapeople.org/tktable/tktable-2.10-3.fc22.src.rpm

- Set configure variables
- Made tests
Comment 4 Jerry James 2015-10-23 18:20:58 EDT
I will take this review.
Comment 5 Antonio Trande 2015-10-23 19:15:30 EDT
Spec URL: https://sagitter.fedorapeople.org/tktable/tktable.spec
SRPM URL: https://sagitter.fedorapeople.org/tktable/tktable-2.10-4.fc22.src.rpm

- Set tclConfig in EPEL5
- Set tests in EPEL5

Running tests on EPEL5 seems a little bit more complicated but works.
Comment 6 Antonio Trande 2015-10-24 06:50:45 EDT
Spec URL: https://sagitter.fedorapeople.org/tktable/tktable.spec
SRPM URL: https://sagitter.fedorapeople.org/tktable/tktable-2.10-5.fc22.src.rpm

- Enabled compiler flags for hardened builds
- Avoid <tclsh: command not found> warnings
Comment 7 Jerry James 2015-10-24 23:27:33 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
1. The existence of -fomit-frame-pointer in tclconfig/tcl.m4 concerns me a
   little.  Maybe it doesn't matter, as I believe that is the default on x86_64
   these days anyway, but I'm not sure that it is the default (and won't harm
   the quality of the debuginfo) on other architectures.  What do you think
   about removing that?

2. The tests fail on x86_64, but the %check script doesn't notice.  Please
   make %check fail if the tests fail, then figure out why the tests are
   failing.  It looks trivial: "bad relief" versus "bad relief type".  I'm
   more concerned that %check succeeded anyway.

3. Since a python source file is included in the package, it should
   BuildRequires: python2-devel or python3-devel as appropriate.

4. Speaking of the python file, should it really be in
   %{_libdir}/tcl8.6/Tktable2.10, or should it be installed where python files
   usually go?

5. html/tkTable.html and README.txt are in both %{_libdir}/tcl8.6/Tktable2.10
   and /usr/share/doc/tktable.  Does they need to be both places?

6. Similarly, license.txt is in both %{_libdir}/tcl8.6/Tktable2.10 and in
   /usr/share/licenses/tktable.  Does it need to be both places?


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 143360 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Buildroot is not present
     This is needed for EPEL 5 support.  Later releases don't need it.
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Ditto: needed for EPEL 5 support.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: tktable-2.10-5.fc24.x86_64.rpm
          tktable-2.10-5.fc24.src.rpm
tktable.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
tktable.x86_64: W: spelling-error %description -l en_US resizable -> re sizable, re-sizable, recognizable
tktable.x86_64: W: spelling-error %description -l en_US scrollbar -> scroll bar, scroll-bar, scroll
tktable.src: W: spelling-error %description -l en_US multi -> mulch, mufti
tktable.src: W: spelling-error %description -l en_US resizable -> re sizable, re-sizable, recognizable
tktable.src: W: spelling-error %description -l en_US scrollbar -> scroll bar, scroll-bar, scroll
2 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: tktable-debuginfo-2.10-5.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
tktable (rpmlib, GLIBC filtered):
    libX11.so.6()(64bit)
    libc.so.6()(64bit)
    rtld(GNU_HASH)
    tcl(abi)
    tk



Provides
--------
tktable:
    libTktable2.10.so()(64bit)
    tktable
    tktable(x86-64)



Unversioned so-files
--------------------
tktable: /usr/lib64/tcl8.6/Tktable2.10/libTktable2.10.so

Source checksums
----------------
http://download.sourceforge.net/tktable/Tktable2.10.tar.gz :
  CHECKSUM(SHA256) this package     : c335117fa1be45fe4d3032e96fd4b4641fff6a4f8467878608dabed11198a4cb
  CHECKSUM(SHA256) upstream package : c335117fa1be45fe4d3032e96fd4b4641fff6a4f8467878608dabed11198a4cb


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1272652 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 8 Antonio Trande 2015-10-25 09:32:14 EDT
(In reply to Jerry James from comment #7)
> Issues:
> =======
> 1. The existence of -fomit-frame-pointer in tclconfig/tcl.m4 concerns me a
>    little.  Maybe it doesn't matter, as I believe that is the default on
> x86_64
>    these days anyway, but I'm not sure that it is the default (and won't harm
>    the quality of the debuginfo) on other architectures.  What do you think
>    about removing that?

Removed; it's turned on with -O2 optimization but disabled:

$ gcc -c -Q -O2 --help=optimizers | grep fomit
  -fomit-frame-pointer        		[disabled]

> 
> 2. The tests fail on x86_64, but the %check script doesn't notice.  Please
>    make %check fail if the tests fail, then figure out why the tests are
>    failing.  It looks trivial: "bad relief" versus "bad relief type".  I'm
>    more concerned that %check succeeded anyway.

Yes, i know; i have signaled to upstream but still none reply.
http://sourceforge.net/p/tktable/mailman/tktable-users/?viewmonth=201510

Those two tests do not fail in EPEL.

> 
> 3. Since a python source file is included in the package, it should
>    BuildRequires: python2-devel or python3-devel as appropriate.
> 
> 4. Speaking of the python file, should it really be in
>    %{_libdir}/tcl8.6/Tktable2.10, or should it be installed where python
> files
>    usually go?

It's a wrapper for Python2; i have packaged as a python sub-package.

> 
> 5. html/tkTable.html and README.txt are in both %{_libdir}/tcl8.6/Tktable2.10
>    and /usr/share/doc/tktable.  Does they need to be both places?
> 
> 6. Similarly, license.txt is in both %{_libdir}/tcl8.6/Tktable2.10 and in
>    /usr/share/licenses/tktable.  Does it need to be both places?
> 

Fixed.
Thanks.

Spec URL: https://sagitter.fedorapeople.org/tktable/tktable.spec
SRPM URL: https://sagitter.fedorapeople.org/tktable/tktable-2.10-6.fc22.src.rpm

- Remove duplicated documentation
- Install python wrapper
- Remove potentially bad flag
Comment 9 Jerry James 2015-10-26 23:31:54 EDT
Here is a modified %check script that fails if any tests fail:

%check
%if 0%{?rhel} && 0%{?rhel} < 6
Xvfb :1 &
export DISPLAY=:1
make test 2>&1 | tee test.log
killall Xvfb
%else
xvfb-run -a make test 2>&1 | tee test.log
%endif
grep -E 'Failed[[:blank:]]+0' test.log > /dev/null

The actual test failure appears to be due to a changed error message in newer versions of tk; see the output of "strings %{_libdir}/libtk.so".  That shouldn't cause the test to fail, so I think you should simply do something like this on the affected Fedora releases:

sed -e 's/\(bad relief\) type/\1/' -i tests/tkTable.test
Comment 10 Antonio Trande 2015-10-27 06:52:17 EDT
(In reply to Jerry James from comment #9)
> Here is a modified %check script that fails if any tests fail:
> 
> %check
> %if 0%{?rhel} && 0%{?rhel} < 6
> Xvfb :1 &
> export DISPLAY=:1
> make test 2>&1 | tee test.log
> killall Xvfb
> %else
> xvfb-run -a make test 2>&1 | tee test.log
> %endif
> grep -E 'Failed[[:blank:]]+0' test.log > /dev/null
> 
> The actual test failure appears to be due to a changed error message in
> newer versions of tk; see the output of "strings %{_libdir}/libtk.so".  That
> shouldn't cause the test to fail, so I think you should simply do something
> like this on the affected Fedora releases:
> 
> sed -e 's/\(bad relief\) type/\1/' -i tests/tkTable.test

Great!

Spec URL: https://sagitter.fedorapeople.org/tktable/tktable.spec
SRPM URL: https://sagitter.fedorapeople.org/tktable/tktable-2.10-7.fc22.src.rpm

- tkTable.test adjusted according to the error message in newer versions of tk (bz#1272652#c9)
- Making 'Make' sensitive to failed tests (bz#1272652#c9)

Rawhide build: http://koji.fedoraproject.org/koji/taskinfo?taskID=11597224
Epel5 build: http://koji.fedoraproject.org/koji/taskinfo?taskID=11597379
Comment 11 Jerry James 2015-10-27 13:18:58 EDT
Looks great.  This package is APPROVED.
Comment 12 Antonio Trande 2015-10-27 13:24:38 EDT
Thank you very much.
Comment 13 Fedora Update System 2015-10-27 17:32:06 EDT
tktable-2.10-7.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-5af6305823
Comment 14 Fedora Update System 2015-10-27 17:32:12 EDT
tktable-2.10-7.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-b9ca1ffdb9
Comment 15 Fedora Update System 2015-11-01 01:59:37 EST
tktable-2.10-7.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update tktable'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-b9ca1ffdb9
Comment 16 Fedora Update System 2015-11-01 19:28:05 EST
tktable-2.10-7.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update tktable'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-5af6305823
Comment 17 Fedora Update System 2015-11-01 21:55:14 EST
tktable-2.10-7.fc21 has been pushed to the Fedora 21 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update tktable'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-58b43d0843
Comment 18 Fedora Update System 2015-11-09 16:53:38 EST
tktable-2.10-7.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 19 Fedora Update System 2015-11-09 19:23:52 EST
tktable-2.10-7.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2015-11-09 19:51:07 EST
tktable-2.10-7.fc21 has been pushed to the Fedora 21 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.